## haxe 3.2.1+dfsg

=== Makefile ===
# Haxe compiler Makefile
#
#  - use 'make' to build all
#  - use 'make haxe' to build only the compiler (not the libraries)
#  - if you want to build quickly, install 'ocamlopt.opt' and change OCAMLOPT=ocamlopt.opt
#
#  Windows users :
#  - use 'make -f Makefile.win' to build for Windows
#  - use 'make MSVC=1 -f Makefile.win' to build for Windows with OCaml/MSVC
#
.SUFFIXES : .ml .mli .cmo .cmi .cmx .mll .mly

INSTALL_DIR=/usr
INSTALL_BIN_DIR=$(INSTALL_DIR)/bin
INSTALL_LIB_DIR=$(INSTALL_DIR)/lib/haxe

OUTPUT=haxe
EXTENSION=
OCAMLOPT?=ocamlopt
OCAMLC?=ocamlc
LFLAGS=

CFLAGS= -g -I libs/extlib -I libs/extc -I libs/neko -I libs/javalib -I libs/ziplib -I libs/swflib -I libs/xml-light -I libs/ttflib -I libs/ilib -I libs/objsize

LIBS=unix str libs/extlib/extLib libs/xml-light/xml-light libs/swflib/swflib \
	libs/extc/extc libs/neko/neko libs/javalib/java libs/ziplib/zip \
	libs/ttflib/ttf libs/ilib/il libs/objsize/objsize

NATIVE_LIBS=-cclib libs/extc/extc_stubs.o -cclib libs/extc/process_stubs.o -cclib -lz -cclib libs/objsize/c_objsize.o

ifeq ($(BYTECODE),1)
	TARGET_FLAG = bytecode
	COMPILER = $(OCAMLC)
	LIB_EXT = cma
	MODULE_EXT = cmo
	NATIVE_LIB_FLAG = -custom
else
	TARGET_FLAG = native
	COMPILER = $(OCAMLOPT)
	LIB_EXT = cmxa
	MODULE_EXT = cmx
endif

CC_CMD = $(COMPILER) $(CFLAGS) -c $<

CC_PARSER_CMD = $(COMPILER) -pp camlp4o $(CFLAGS) -c parser.ml

RELDIR=../../..

MODULES=ast type lexer common genxml parser typecore optimizer typeload \
	codegen gencommon genas3 gencpp genjs genneko genphp \
	genswf9 genswf genjava gencs genpy interp dce analyzer filters typer matcher version main

ADD_REVISION?=0

BRANCH=$(shell echo $$APPVEYOR_REPO_NAME | grep -q /haxe && echo $$APPVEYOR_REPO_BRANCH || echo $$TRAVIS_REPO_SLUG | grep -q /haxe && echo $$TRAVIS_BRANCH || git rev-parse --abbrev-ref HEAD)
COMMIT_SHA=$(shell git rev-parse --short HEAD)
COMMIT_DATE=$(shell git show -s --format=%ci HEAD | grep -oh ....-..-..)
PACKAGE_FILE_NAME=haxe_$(COMMIT_DATE)_$(BRANCH)_$(COMMIT_SHA)

# using $(CURDIR) on Windows will not work since it might be a Cygwin path
ifdef SYSTEMROOT
	EXTENSION=.exe
else
	export HAXE_STD_PATH=$(CURDIR)/std
endif

all: libs haxe

libs:
	make -C libs/extlib OCAMLOPT=$(OCAMLOPT) OCAMLC=$(OCAMLC) $(TARGET_FLAG)
	make -C libs/extc OCAMLOPT=$(OCAMLOPT) OCAMLC=$(OCAMLC) $(TARGET_FLAG)
	make -C libs/neko OCAMLOPT=$(OCAMLOPT) OCAMLC=$(OCAMLC) $(TARGET_FLAG)
	make -C libs/javalib OCAMLOPT=$(OCAMLOPT) OCAMLC=$(OCAMLC) $(TARGET_FLAG)
	make -C libs/ilib OCAMLOPT=$(OCAMLOPT) OCAMLC=$(OCAMLC) $(TARGET_FLAG)
	make -C libs/ziplib OCAMLOPT=$(OCAMLOPT) OCAMLC=$(OCAMLC) $(TARGET_FLAG)
	make -C libs/swflib OCAMLOPT=$(OCAMLOPT) OCAMLC=$(OCAMLC) $(TARGET_FLAG)
	make -C libs/xml-light OCAMLOPT=$(OCAMLOPT) OCAMLC=$(OCAMLC) $(TARGET_FLAG)
	make -C libs/ttflib OCAMLOPT=$(OCAMLOPT) OCAMLC=$(OCAMLC) $(TARGET_FLAG)
	make -C libs/objsize OCAMLOPT=$(OCAMLOPT) OCAMLC=$(OCAMLC) $(TARGET_FLAG)

haxe: $(MODULES:=.$(MODULE_EXT))
	$(COMPILER) -o $(OUTPUT) $(NATIVE_LIBS) $(NATIVE_LIB_FLAG) $(LFLAGS) $(LIBS:=.$(LIB_EXT)) $(MODULES:=.$(MODULE_EXT))

haxelib:
	(cd $(CURDIR)/extra/haxelib_src && $(CURDIR)/$(OUTPUT) haxelib.hxml && nekotools boot bin/haxelib.n)
	cp extra/haxelib_src/bin/haxelib$(EXTENSION) haxelib$(EXTENSION)

tools: haxelib

install:
	-rm -f $(INSTALL_LIB_DIR)
	-mkdir -p $(INSTALL_LIB_DIR)
	rm -rf $(INSTALL_LIB_DIR)/std
	cp -rf std $(INSTALL_LIB_DIR)/std
	cp -rf extra $(INSTALL_LIB_DIR)
	-mkdir -p $(INSTALL_LIB_DIR)/lib
	rm -f $(INSTALL_BIN_DIR)/haxe
	cp haxe $(INSTALL_LIB_DIR)
	ln -s $(INSTALL_LIB_DIR)/haxe $(INSTALL_BIN_DIR)/haxe
	chmod -R a+rx $(INSTALL_LIB_DIR)
	chmod 777 $(INSTALL_LIB_DIR)/lib
	# cp extra/haxelib_src/haxelib_script.sh $(INSTALL_DIR)/bin/haxelib
	echo "#!/bin/sh" > $(INSTALL_BIN_DIR)/haxelib
	echo "exec haxe -cp $(INSTALL_LIB_DIR)/extra/haxelib_src/src --run tools.haxelib.Main \"\$$@\"" >> $(INSTALL_BIN_DIR)/haxelib
	chmod a+rx $(INSTALL_BIN_DIR)/haxe $(INSTALL_BIN_DIR)/haxelib

# will install native version of the tools instead of script ones
install_tools: tools
	cp haxelib ${INSTALL_BIN_DIR}/haxelib
	chmod a+rx $(INSTALL_BIN_DIR)/haxelib

uninstall:
	rm -rf $(INSTALL_BIN_DIR)/haxe $(INSTALL_BIN_DIR)/haxelib $(INSTALL_LIB_DIR)

# Modules

analyzer.$(MODULE_EXT): ast.$(MODULE_EXT) type.$(MODULE_EXT) common.$(MODULE_EXT) codegen.$(MODULE_EXT)

codegen.$(MODULE_EXT): optimizer.$(MODULE_EXT) typeload.$(MODULE_EXT) typecore.$(MODULE_EXT) type.$(MODULE_EXT) genxml.$(MODULE_EXT) common.$(MODULE_EXT) ast.$(MODULE_EXT)

common.$(MODULE_EXT): type.$(MODULE_EXT) ast.$(MODULE_EXT) libs/ilib/il.$(LIB_EXT)

dce.$(MODULE_EXT): ast.$(MODULE_EXT) common.$(MODULE_EXT) codegen.$(MODULE_EXT) type.$(MODULE_EXT)

filters.$(MODULE_EXT): ast.$(MODULE_EXT) analyzer.$(MODULE_EXT) common.$(MODULE_EXT) type.$(MODULE_EXT) dce.$(MODULE_EXT) codegen.$(MODULE_EXT) typecore.$(MODULE_EXT)

genas3.$(MODULE_EXT): type.$(MODULE_EXT) common.$(MODULE_EXT) codegen.$(MODULE_EXT) ast.$(MODULE_EXT)

gencommon.$(MODULE_EXT): type.$(MODULE_EXT) common.$(MODULE_EXT) codegen.$(MODULE_EXT) ast.$(MODULE_EXT) libs/ilib/il.$(LIB_EXT)

gencpp.$(MODULE_EXT): type.$(MODULE_EXT) lexer.$(MODULE_EXT) common.$(MODULE_EXT) codegen.$(MODULE_EXT) ast.$(MODULE_EXT) gencommon.$(MODULE_EXT)

gencs.$(MODULE_EXT): type.$(MODULE_EXT) lexer.$(MODULE_EXT) gencommon.$(MODULE_EXT) common.$(MODULE_EXT) codegen.$(MODULE_EXT) ast.$(MODULE_EXT) libs/ilib/il.$(LIB_EXT)

genjava.$(MODULE_EXT): type.$(MODULE_EXT) gencommon.$(MODULE_EXT) common.$(MODULE_EXT) codegen.$(MODULE_EXT) ast.$(MODULE_EXT)

genjs.$(MODULE_EXT): type.$(MODULE_EXT) optimizer.$(MODULE_EXT) lexer.$(MODULE_EXT) common.$(MODULE_EXT) codegen.$(MODULE_EXT) ast.$(MODULE_EXT)

genneko.$(MODULE_EXT): type.$(MODULE_EXT) lexer.$(MODULE_EXT) common.$(MODULE_EXT) codegen.$(MODULE_EXT) ast.$(MODULE_EXT)

genphp.$(MODULE_EXT): type.$(MODULE_EXT) lexer.$(MODULE_EXT) common.$(MODULE_EXT) codegen.$(MODULE_EXT) ast.$(MODULE_EXT)

genpy.$(MODULE_EXT): type.$(MODULE_EXT) lexer.$(MODULE_EXT) common.$(MODULE_EXT) codegen.$(MODULE_EXT) ast.$(MODULE_EXT)

genswf.$(MODULE_EXT): type.$(MODULE_EXT) genswf9.$(MODULE_EXT) common.$(MODULE_EXT) ast.$(MODULE_EXT)

genswf9.$(MODULE_EXT): type.$(MODULE_EXT) lexer.$(MODULE_EXT) common.$(MODULE_EXT) codegen.$(MODULE_EXT) ast.$(MODULE_EXT)

genxml.$(MODULE_EXT): type.$(MODULE_EXT) lexer.$(MODULE_EXT) common.$(MODULE_EXT) ast.$(MODULE_EXT)

interp.$(MODULE_EXT): typecore.$(MODULE_EXT) type.$(MODULE_EXT) lexer.$(MODULE_EXT) genneko.$(MODULE_EXT) common.$(MODULE_EXT) codegen.$(MODULE_EXT) ast.$(MODULE_EXT) genswf.$(MODULE_EXT) genjava.$(MODULE_EXT) gencs.$(MODULE_EXT) parser.$(MODULE_EXT) libs/ilib/il.$(LIB_EXT)

matcher.$(MODULE_EXT): optimizer.$(MODULE_EXT) codegen.$(MODULE_EXT) typecore.$(MODULE_EXT) type.$(MODULE_EXT) typer.$(MODULE_EXT) common.$(MODULE_EXT) ast.$(MODULE_EXT)

main.$(MODULE_EXT): filters.$(MODULE_EXT) matcher.$(MODULE_EXT) typer.$(MODULE_EXT) typeload.$(MODULE_EXT) typecore.$(MODULE_EXT) type.$(MODULE_EXT) parser.$(MODULE_EXT) optimizer.$(MODULE_EXT) lexer.$(MODULE_EXT) interp.$(MODULE_EXT) genxml.$(MODULE_EXT) genswf.$(MODULE_EXT) genphp.$(MODULE_EXT) genneko.$(MODULE_EXT) genjs.$(MODULE_EXT) gencpp.$(MODULE_EXT) genas3.$(MODULE_EXT) common.$(MODULE_EXT) codegen.$(MODULE_EXT) ast.$(MODULE_EXT) gencommon.$(MODULE_EXT) genjava.$(MODULE_EXT) gencs.$(MODULE_EXT) genpy.$(MODULE_EXT) version.$(MODULE_EXT) libs/ilib/il.$(LIB_EXT)

optimizer.$(MODULE_EXT): typecore.$(MODULE_EXT) type.$(MODULE_EXT) parser.$(MODULE_EXT) common.$(MODULE_EXT) ast.$(MODULE_EXT)

parser.$(MODULE_EXT): parser.ml lexer.$(MODULE_EXT) common.$(MODULE_EXT) ast.$(MODULE_EXT)
	$(CC_PARSER_CMD)

type.$(MODULE_EXT): ast.$(MODULE_EXT)

typecore.$(MODULE_EXT): type.$(MODULE_EXT) common.$(MODULE_EXT) ast.$(MODULE_EXT)

typeload.$(MODULE_EXT): typecore.$(MODULE_EXT) type.$(MODULE_EXT) parser.$(MODULE_EXT) optimizer.$(MODULE_EXT) lexer.$(MODULE_EXT) common.$(MODULE_EXT) ast.$(MODULE_EXT)

typer.$(MODULE_EXT): typeload.$(MODULE_EXT) typecore.$(MODULE_EXT) type.$(MODULE_EXT) parser.$(MODULE_EXT) optimizer.$(MODULE_EXT) lexer.$(MODULE_EXT) interp.$(MODULE_EXT) genneko.$(MODULE_EXT) genjs.$(MODULE_EXT) common.$(MODULE_EXT) codegen.$(MODULE_EXT) ast.$(MODULE_EXT) filters.$(MODULE_EXT) gencommon.$(MODULE_EXT)

lexer.$(MODULE_EXT): lexer.ml

lexer.$(MODULE_EXT): ast.$(MODULE_EXT)

ast.$(MODULE_EXT):

version.$(MODULE_EXT):
	$(MAKE) -f Makefile.version_extra -s ADD_REVISION=$(ADD_REVISION) BRANCH=$(BRANCH) COMMIT_SHA=$(COMMIT_SHA) COMMIT_DATE=$(COMMIT_DATE) > version.ml
	$(COMPILER) $(CFLAGS) -c version.ml

# Package

package_bin:
	mkdir -p out
	rm -rf $(PACKAGE_FILE_NAME) $(PACKAGE_FILE_NAME).tar.gz
	# Copy the package contents to $(PACKAGE_FILE_NAME)
	mkdir -p $(PACKAGE_FILE_NAME)
	cp -r $(OUTPUT) haxelib$(EXTENSION) std extra/LICENSE.txt extra/CONTRIB.txt extra/CHANGES.txt $(PACKAGE_FILE_NAME)
	# archive
	tar -zcf out/$(PACKAGE_FILE_NAME).tar.gz $(PACKAGE_FILE_NAME)
	rm -r $(PACKAGE_FILE_NAME)

# Clean

clean: clean_libs clean_haxe clean_tools

clean_libs:
	make -C libs/extlib clean
	make -C libs/extc clean
	make -C libs/neko clean
	make -C libs/ziplib clean
	make -C libs/javalib clean
	make -C libs/ilib clean
	make -C libs/swflib clean
	make -C libs/xml-light clean
	make -C libs/ttflib clean
	make -C libs/objsize clean

clean_haxe:
	rm -f $(MODULES:=.obj) $(MODULES:=.o) $(MODULES:=.cmx) $(MODULES:=.cmi) $(MODULES:=.cmo) lexer.ml $(OUTPUT)

clean_tools:
	rm -f $(OUTPUT) haxelib

# SUFFIXES

.ml.cmx:
	$(CC_CMD)

.ml.cmo:
	$(CC_CMD)

.mll.ml:
	ocamllex $<

.PHONY: haxe libs version.cmx version.cmo haxelib

=== libs/Makefile ===
OCAMLOPT = ocamlopt
OCAMLC = ocamlc
TARGET_FLAG = all
LIBS=extlib extc neko javalib ilib ziplib swflib xml-light ttflib objsize

all: $(LIBS)
$(LIBS):
	make -C $@ OCAMLOPT=$(OCAMLOPT) OCAMLC=$(OCAMLC) $(TARGET_FLAG)

clean:
	make -C extlib clean
	make -C extc clean
	make -C neko clean
	make -C ziplib clean
	make -C javalib clean
	make -C swflib clean
	make -C xml-light clean
	make -C ttflib clean

.PHONY: all clean $(LIBS)

Makefile: ;

=== libs/extc/Makefile ===
CFLAGS = -I zlib
LIBS = -I ../extlib
OCAMLOPT=ocamlopt
OCAMLC=ocamlc
SRC = extc.ml process.ml extc_stubs.c process_stubs.c

all: bytecode native

bytecode: extc.cma

native: extc.cmxa

extc.cma: extc_stubs.o process_stubs.o extc.ml process.ml
	$(OCAMLC) -a -o extc.cma $(LIBS) extc.ml process.ml

extc.cmxa: extc.ml process.ml extc_stubs.o process_stubs.o
	$(OCAMLOPT) -a -o extc.cmxa $(LIBS) extc.ml process.ml

extc_stubs.o: extc_stubs.c
	$(OCAMLC) $(CFLAGS) extc_stubs.c

process_stubs.o: process_stubs.c
	$(OCAMLC) $(CFLAGS) process_stubs.c
	
clean:
	rm -f extc.cma extc.cmi extc.cmx extc.cmxa extc.o extc.obj extc.lib extc_stubs.obj extc_stubs.o process.cmx process.obj process.cmi process_stubs.obj process_stubs.o
	rm -f extc.a libextc.a libextc.lib extc.cmo process.cmo

test: native
	ocamlopt -o test.exe -I ../extLib extLib.cmxa zlib/zlib.lib extc_stubs.obj process_stubs.obj extc.cmxa test.ml
	
.PHONY: all bytecode native clean
Makefile: ;
$(SRC): ;

=== libs/extlib/Makefile ===
# Makefile contributed by Alain Frisch
OCAMLOPT=ocamlopt
OCAMLC=ocamlc

MODULES = \
 enum bitSet dynArray extArray extHashtbl extList extString global rbuffer IO option \
 pMap std uChar uTF8 base64 unzip refList optParse dllist multiArray

# the list is topologically sorted

MLI = $(MODULES:=.mli)
SRC = $(MLI) $(MODULES:=.ml) extLib.ml

all: bytecode native

opt: native

bytecode: extLib.cma

native: extLib.cmxa

extLib.cma: $(SRC)
	$(OCAMLC) -a -o extLib.cma $(SRC)

extLib.cmxa: $(SRC)
	$(OCAMLOPT) -g -a -o extLib.cmxa $(SRC)

doc:
	$(OCAMLC) -c $(MODULES:=.mli)
	mkdir -p doc/
	ocamldoc -sort -html -d doc/ $(MODULES:=.mli)
	cp odoc_style.css doc/style.css

copy:
	mv *.cmi *.cmx *.cma *.cmxa extLib.lib c:/ocaml/lib/

install:
	cp META.txt META
	ocamlfind install extlib META *.cmi *.cma $(MLI) $(wildcard *.cmxa) $(wildcard *.a)

uninstall:
	ocamlfind remove extlib

clean:
	rm -f $(wildcard *.cmo) $(wildcard *.cmx) $(wildcard *.o) $(wildcard *.cmi) $(wildcard *.cma) $(wildcard *.cmxa) $(wildcard *.a) $(wildcard *.lib) $(wildcard *.obj)
	rm -Rf doc

.PHONY: all opt bytecode native doc copy install uninstall clean

Makefile: ;

$(SRC): ;

=== libs/javalib/Makefile ===
OCAMLOPT=ocamlopt
OCAMLC=ocamlc
SRC=jData.ml jReader.ml

all: bytecode native

native: java.cmxa
bytecode: java.cma

java.cmxa: $(SRC)
	$(OCAMLOPT) -g -I ../extlib -a -o java.cmxa $(SRC)

java.cma: $(SRC)
	$(OCAMLC) -g -I ../extlib -a -o java.cma $(SRC)

clean:
	rm -rf java.cmxa java.cma java.lib java.a $(wildcard *.cmx) $(wildcard *.obj) $(wildcard *.o) $(wildcard *.cmi) $(wildcard *.cmo)

.PHONY: all bytecode native clean

Makefile: ;
$(SRC): ;

=== libs/objsize/Makefile ===
CFLAGS = -I .
LIBS =
OCAMLOPT=ocamlopt
OCAMLC=ocamlc
SRC=objsize.mli objsize.ml

all: bytecode native

bytecode: objsize.cma

native: objsize.cmxa

objsize.cma: c_objsize.o $(SRC)
	$(OCAMLC) -a -o objsize.cma $(LIBS) $(SRC)

objsize.cmxa: c_objsize.o $(SRC)
	$(OCAMLOPT) -a -o objsize.cmxa $(LIBS) $(SRC)

c_objsize.o: c_objsize.c
	$(OCAMLC) $(CFLAGS) c_objsize.c

clean:
	rm -rf $(wildcard *.cma) $(wildcard *.cmxa) $(wildcard *.cmx) $(wildcard *.cmi) $(wildcard *.cmo) $(wildcard *.obj) $(wildcard *.o)

.PHONY: all bytecode native clean

Makefile: ;
$(SRC): ;
c_objsize.c: ;

=== libs/swflib/Makefile ===
# Makefile generated by OCamake
# http://tech.motion-twin.com
OCAMLOPT=ocamlopt
OCAMLC=ocamlc
.SUFFIXES : .ml .mli .cmo .cmi .cmx .mll .mly

CFLAGS= -I ../extlib -I ../extc -g
LIBS=

SRC=actionScript.ml as3hl.mli as3.mli png.ml swflib.sln swf.ml swfPic.ml as3code.ml as3hlparse.ml as3parse.ml png.mli swfParser.ml

MODULES=as3code.cmx png.cmx swf.cmx actionScript.cmx as3parse.cmx swfPic.cmx as3hlparse.cmx swfParser.cmx

all: native bytecode

native: swflib.cmxa

bytecode: swflib.cma

swflib.cmxa: $(MODULES)
	$(OCAMLOPT) -o swflib.cmxa -a $(LIBS) $(MODULES)

swflib.cma: $(MODULES:.cmx=.cmo)
	$(OCAMLC) -o swflib.cma -a $(LFLAGS) $(LIBS) $(MODULES:.cmx=.cmo)

actionScript.cmx: swf.cmx

actionScript.cmo: swf.cmi

as3code.cmo: as3.cmi

as3code.cmx: as3.cmi

as3hl.cmi: as3.cmi

as3hlparse.cmo: as3parse.cmo as3hl.cmi as3code.cmo as3.cmi

as3hlparse.cmx: as3parse.cmx as3hl.cmi as3code.cmx as3.cmi

as3parse.cmo: as3code.cmo as3.cmi

as3parse.cmx: as3code.cmx as3.cmi

png.cmo: png.cmi

png.cmx: png.cmi

swf.cmo: as3.cmi

swf.cmx: as3.cmi

swfParser.cmo: swf.cmo as3parse.cmo actionScript.cmo

swfParser.cmx: swf.cmx as3parse.cmx actionScript.cmx

swfPic.cmx: swf.cmx png.cmi

clean:
	rm -f swflib.cmxa swflib.cma swflib.lib swflib.a as3.cmi as3hl.cmi
	rm -f $(MODULES) $(MODULES:.cmx=.obj) $(MODULES:.cmx=.cmi) $(MODULES:.cmx=.o) $(MODULES:.cmx=.cmo)

# SUFFIXES
.ml.cmo:
	$(OCAMLC) $(CFLAGS) -c $<

.ml.cmx:
	$(OCAMLOPT) $(CFLAGS) -c $<

.mli.cmi:
	$(OCAMLC) $(CFLAGS) $<

.mll.ml:
	ocamllex $<

.mly.ml:
	ocamlyacc $<

.PHONY: all bytecode native clean

Makefile: ;
$(SRC): ;

=== libs/ttflib/Makefile ===
OCAMLOPT=ocamlopt
OCAMLC=ocamlc

FLAGS=-I ../extlib -I ../swflib
FILES=tTFData tTFParser tTFTools tTFSwfWriter tTFCanvasWriter tTFJsonWriter
LIBS=extLib swflib unix

OUTPUT=ttf

all: native bytecode

native: ttf.cmxa

bytecode: ttf.cma

ttf.cmxa: $(FILES:=.ml)
	$(OCAMLOPT) $(FLAGS) $(FILES:=.ml) -g -a -o ttf.cmxa

ttf.cma: $(FILES:=.ml)
	$(OCAMLC) $(FLAGS) $(FILES:=.ml) -g -a -o ttf.cma

exec:
	$(OCAMLOPT) $(FLAGS) $(LIBS:=.cmxa) $(FILES:=.ml) main.ml -g -o $(OUTPUT)

clean:
	rm -rf ttf.cmxa ttf.cma ttf.lib ttf.a $(wildcard *.cmx) $(wildcard *.obj) $(wildcard *.o) $(wildcard *.cmi) $(wildcard *.cmo)

.PHONY: all native bytecode clean exec

Makefile: ;
$(FILES:=.ml): ;

=== libs/xml-light/Makefile ===
# Makefile generated by OCamake 
# http://tech.motion-twin.com
VERSION=2.3
OCAMLOPT=ocamlopt
OCAMLC=ocamlc
OCAMLFIND=ocamlfind

.SUFFIXES : .ml .mli .cmo .cmx .cmi .mll .mly

INSTALLDIR=`$(OCAMLC) -where`
CFLAGS=
LFLAGS= -a
LIBS=
SRC=dtd.mli xml.dsp xml_lexer.mli xml.ml xmlParser.ml xml_parser.mly dtd.ml test.ml xml.dsw xml_lexer.mll xml.mli xmlParser.mli


all: bytecode test.exe doc

opt: native

native: xml-light.cmxa

bytecode: xml-light.cma

installcommon: all
	cp xml.mli xmlParser.mli dtd.mli xml.cmi xmlParser.cmi dtd.cmi $(INSTALLDIR)

installbyte: all installcommon
	cp xml-light.cma $(INSTALLDIR)

installopt: opt installcommon
	cp xml-light.a xml-light.cmxa xml.cmx dtd.cmx xmlParser.cmx $(INSTALLDIR)

install: installbyte installopt

wininstall: all opt
	cp xml-light.cmxa xml-light.lib xml-light.cma xml.mli xmlParser.mli dtd.mli xml.cmi xmlParser.cmi dtd.cmi xml.cmx dtd.cmx xmlParser.cmx c:\ocaml\lib

install_ocamlfind: all opt
	cp META.in META
	sed -itmp "s|@VERSION@|$(VERSION)|g" META
	rm -rf METAtmp
	$(OCAMLFIND) install xml-light META xml-light.a xml-light.cma xml-light.cmxa xml.cmx dtd.cmx xmlParser.cmx xml.mli xmlParser.mli dtd.mli xml.cmi xmlParser.cmi dtd.cmi

doc: doc/index.html
doc/index.html: xml.mli dtd.mli xmlParser.mli
	mkdir -p doc
	ocamldoc -sort -html -d doc xml.mli dtd.mli xmlParser.mli

test.exe: xml-light.cma
	$(OCAMLC) xml-light.cma test.ml -o test.exe

test_opt.exe: xml-light.cmxa
	$(OCAMLOPT) xml-light.cmxa test.ml -o test_opt.exe

xml-light.cma: xml_parser.cmo xml_lexer.cmo dtd.cmo xmlParser.cmo xml.cmo 
	$(OCAMLC) -o xml-light.cma $(LFLAGS) $(LIBS) xml_parser.cmo xml_lexer.cmo dtd.cmo xmlParser.cmo xml.cmo

xml-light.cmxa: xml_parser.cmx xml_lexer.cmx dtd.cmx xmlParser.cmx xml.cmx 
	$(OCAMLOPT) -o xml-light.cmxa $(LFLAGS) $(LIBS) xml_parser.cmx xml_lexer.cmx dtd.cmx xmlParser.cmx xml.cmx

dtd.cmo: xml.cmi xml_lexer.cmi dtd.cmi

dtd.cmx: xml.cmi xml_lexer.cmi dtd.cmi

xml.cmo: dtd.cmi xmlParser.cmi xml_lexer.cmi xml.cmi

xml.cmx: dtd.cmi xmlParser.cmi xml_lexer.cmi xml.cmi

xmlParser.cmo: dtd.cmi xml.cmi xml_lexer.cmi xmlParser.cmi

xmlParser.cmx: dtd.cmi xml.cmi xml_lexer.cmi xmlParser.cmi

dtd.cmi: xml.cmi

xml.cmi: 

xmlParser.cmi: dtd.cmi xml.cmi

xml_lexer.cmi: dtd.cmi

xml_parser.cmo: xml_parser.ml dtd.cmi xml_parser.mli xml_parser.cmi

xml_parser.cmx: xml_parser.ml dtd.cmi xml_parser.mli xml_parser.cmi

xml_parser.cmi: xml_parser.mli dtd.cmi xml.cmi

xml_lexer.cmo: xml_lexer.ml xml_lexer.cmi

xml_lexer.cmx: xml_lexer.ml xml_lexer.cmi

clean:
	rm -f xml-light.cma test.exe dtd.cmo dtd.cmi test.cmo test.cmi xml.cmo xml.cmi xmlParser.cmo xmlParser.cmi dtd.cmi xml.cmi xmlParser.cmi xml_lexer.cmi xml_lexer.cmo xml_lexer.ml xml_parser.mli xml_parser.cmi xml_parser.ml xml_parser.cmo
	rm -f xml-light.lib xml-light.a xml-light.cmxa test_opt.exe dtd.cmx dtd.obj dtd.o test.cmx test.obj test.o xml.cmx xml.obj xml.o xmlParser.cmx xmlParser.obj xmlParser.o xml_lexer.cmx xml_lexer.obj xml_lexer.o xml_parser.cmx xml_parser.obj xml_parser.o
	rm -rf doc


# SUFFIXES
.ml.cmo:
	$(OCAMLC) $(CFLAGS) -c $<

.ml.cmx:
	$(OCAMLOPT) $(CFLAGS) -c $<

.mli.cmi:
	$(OCAMLC) $(CFLAGS) $<

.mll.ml:
	ocamllex $<

.mly.ml:
	ocamlyacc $<

Makefile: ;
$(SRC): ;
.PHONY: all opt native bytecode installcommon installbyte installopt install wininstall install_ocamlfind doc clean

=== debian/changelog ===
haxe (1:3.2.1+dfsg-1build1) xenial; urgency=medium

  * No-change rebuild for ncurses6 transition.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 07 Feb 2016 15:53:13 +0000

haxe (1:3.2.1+dfsg-1) unstable; urgency=low

  * New upstream version.

 -- Andy Li <andy@onthewings.net>  Wed, 14 Oct 2015 10:42:48 +0800

haxe (1:3.2.0+dfsg-1) unstable; urgency=low

  * Adopt package (Closes: #799151).
    + Set maintainer to myself.
  * Set Vcs-* fields to Haxe Foundation haxe-debian git repo.
  * New upstream version.
    + Update neko version dependency.
  * Remove outdated and discontinued emacs haxe mode.
  * Clean up copyright.
    + Remove entries of removed files.
  * Update d/watch and get-orig-source target
    + Create tar manually to include git submodules.

 -- Andy Li <andy@onthewings.net>  Wed, 26 Aug 2015 15:01:06 +0800

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for Haxe.

%:
	dh $@ --with bash-completion

PKD   = $(abspath $(dir $(MAKEFILE_LIST)))
PKG   = haxe
UVER  = $(shell dpkg-parsechangelog -l$(PKD)/changelog | perl -ne 'print $$1 if m{^Version:\s+(?:\d+:)?(\d.*)(?:\-\d+.*)};')
DTYPE = +dfsg
VER  ?= $(subst $(DTYPE),,$(UVER))

override_dh_auto_configure:

override_dh_auto_build:
	# Check to see if ocamlopt exists. If not, bytecompile everything.
	command -v ocamlopt && dh_auto_build || dh_auto_build -- BYTECODE=1
	# Compile haxelib to neko
	dh_auto_build -- tools

override_dh_auto_install:

override_dh_fixperms:
	dh_fixperms
	# https://github.com/HaxeFoundation/haxe/commit/7ecbc2baaef0e2f653f43b01071ffff0050ec5d3
	cd $(CURDIR)/debian/haxe/usr/share/haxe/ && chmod a-x std/js/Boot.hx std/js/_std/Type.hx std/php/_std/haxe/ds/StringMap.hx

override_dh_strip:
	# haxelib is the neko vm appended with neko bytecode. It should not be stripped
	dh_strip --exclude=haxelib

override_dh_clean:
	dh_clean
	# https://github.com/HaxeFoundation/ocamllibs/pull/17
	rm -f $(CURDIR)/libs/extc/process.o
	rm -f $(CURDIR)/libs/objsize/objsize.a

get-orig-source:
	# create tar manually from git, in order to get submodules and remove js source files
	git clone --branch $(VER) --depth 1 --recursive https://github.com/HaxeFoundation/haxe.git orig-source
	cd orig-source && \
		rm std/js/*.js && git commit -am "removed js source files for debian" && \
		python $(CURDIR)/debian/git-archive-all ../../$(PKG)_$(VER)$(DTYPE).orig.tar.gz
	rm -rf orig-source

=== debian/watch ===
version=3
opts="dversionmangle=s/\+dfsg//,uversionmangle=s/-/~/g,repacksuffix=+dfsg"\
 https://github.com/HaxeFoundation/haxe/releases .*/(\d\S*)\.tar\.gz

## haxe 3.4.0

=== Makefile ===
# Haxe compiler Makefile
#
#  - use 'make' to build all
#  - use 'make haxe' to build only the compiler (not the libraries)
#  - if you want to build quickly, install 'ocamlopt.opt' and change OCAMLOPT=ocamlopt.opt
#
#  Windows users :
#  - use 'make -f Makefile.win' to build for Windows
#  - use 'make MSVC=1 -f Makefile.win' to build for Windows with OCaml/MSVC
#
.SUFFIXES : .ml .mli .cmo .cmi .cmx .mll .mly

INSTALL_DIR=$(DESTDIR)/usr
INSTALL_BIN_DIR=$(INSTALL_DIR)/bin
INSTALL_LIB_DIR=$(INSTALL_DIR)/lib/haxe
INSTALL_STD_DIR=$(INSTALL_LIB_DIR)/std
PACKAGE_OUT_DIR=out
PACKAGE_SRC_EXTENSION=.tar.gz

PLATFORM?=unix

OUTPUT=haxe
EXTENSION=
OCAMLOPT?=ocamlopt
OCAMLC?=ocamlc
LFLAGS=
STATICLINK?=0

CFLAGS= -bin-annot
ALL_CFLAGS= $(CFLAGS) -g -w -3 -I libs/extlib -I libs/extc -I libs/neko -I libs/javalib -I libs/ziplib -I libs/swflib -I libs/xml-light -I libs/ttflib -I libs/ilib -I libs/objsize -I libs/pcre \
	-I src -I src/context -I src/generators -I src/macro -I src/optimization -I src/syntax -I src/typing -I src/display

LIBS=unix str libs/extlib/extLib libs/xml-light/xml-light libs/swflib/swflib \
	libs/extc/extc libs/neko/neko libs/javalib/java libs/ziplib/zip \
	libs/ttflib/ttf libs/ilib/il libs/objsize/objsize libs/pcre/pcre


ifneq ($(STATICLINK),0)
LIB_PARAMS= -cclib '-Wl,-Bstatic -lpcre -lz -Wl,-Bdynamic '

else
LIB_PARAMS?= -cclib -lpcre -cclib -lz

endif

NATIVE_LIBS=-cclib libs/extc/extc_stubs.o -cclib libs/extc/process_stubs.o -cclib libs/objsize/c_objsize.o -cclib libs/pcre/pcre_stubs.o -ccopt -L/usr/local/lib $(LIB_PARAMS)

ifeq ($(BYTECODE),1)
	TARGET_FLAG = bytecode
	COMPILER = $(OCAMLC)
	LIB_EXT = cma
	MODULE_EXT = cmo
	NATIVE_LIB_FLAG = -custom
else
	TARGET_FLAG = native
	COMPILER = $(OCAMLOPT)
	LIB_EXT = cmxa
	MODULE_EXT = cmx
endif

CC_CMD = $(COMPILER) $(ALL_CFLAGS) -c $<

CC_PARSER_CMD = $(COMPILER) -pp camlp4o $(ALL_CFLAGS) -c src/syntax/parser.ml

RELDIR=../../..

MODULES=json version globals path context/meta syntax/ast display/displayTypes typing/type typing/error \
	syntax/lexer context/common generators/genxml \
	syntax/parser typing/abstract typing/typecore display/display optimization/optimizerTexpr \
	optimization/optimizer typing/overloads typing/typeload generators/codegen generators/gencommon generators/genas3 \
	generators/gencpp generators/genjs generators/genneko generators/genphp generators/genphp7 generators/genswf9 \
	generators/genswf generators/genjava generators/gencs generators/genpy macro/macroApi macro/interp generators/hlcode generators/hlopt generators/hlinterp generators/hl2c \
	generators/genlua \
	optimization/dce optimization/analyzerConfig optimization/analyzerTypes optimization/analyzerTexpr \
	optimization/analyzerTexprTransformer optimization/analyzer generators/genhl \
	optimization/filters macro/hlmacro macro/macroContext typing/typer typing/matcher display/displayOutput server main

ADD_REVISION?=0

BRANCH=$(shell echo $$APPVEYOR_REPO_NAME | grep -q /haxe && echo $$APPVEYOR_REPO_BRANCH || echo $$TRAVIS_REPO_SLUG | grep -q /haxe && echo $$TRAVIS_BRANCH || git rev-parse --abbrev-ref HEAD)
COMMIT_SHA=$(shell git rev-parse --short HEAD)
COMMIT_DATE=$(shell \
	if [ "$$(uname)" = "Darwin" ]; then \
		date -u -r $$(git show -s --format=%ct HEAD) +%Y%m%d%H%M%S; \
	else \
		date -u -d @$$(git show -s --format=%ct HEAD) +%Y%m%d%H%M%S; \
	fi \
)
PACKAGE_FILE_NAME=haxe_$(COMMIT_DATE)_$(COMMIT_SHA)
HAXE_VERSION=$(shell $(OUTPUT) -version 2>&1 | awk '{print $$1;}')

# using $(CURDIR) on Windows will not work since it might be a Cygwin path
ifdef SYSTEMROOT
	EXTENSION=.exe
else
	export HAXE_STD_PATH=$(CURDIR)/std
endif

all: libs haxe tools

libs:
	make -C libs/extlib OCAMLOPT=$(OCAMLOPT) OCAMLC=$(OCAMLC) $(TARGET_FLAG)
	make -C libs/extc OCAMLOPT=$(OCAMLOPT) OCAMLC=$(OCAMLC) $(TARGET_FLAG)
	make -C libs/neko OCAMLOPT=$(OCAMLOPT) OCAMLC=$(OCAMLC) $(TARGET_FLAG)
	make -C libs/javalib OCAMLOPT=$(OCAMLOPT) OCAMLC=$(OCAMLC) $(TARGET_FLAG)
	make -C libs/ilib OCAMLOPT=$(OCAMLOPT) OCAMLC=$(OCAMLC) $(TARGET_FLAG)
	make -C libs/ziplib OCAMLOPT=$(OCAMLOPT) OCAMLC=$(OCAMLC) $(TARGET_FLAG)
	make -C libs/swflib OCAMLOPT=$(OCAMLOPT) OCAMLC=$(OCAMLC) $(TARGET_FLAG)
	make -C libs/xml-light OCAMLOPT=$(OCAMLOPT) OCAMLC=$(OCAMLC) $(TARGET_FLAG)
	make -C libs/ttflib OCAMLOPT=$(OCAMLOPT) OCAMLC=$(OCAMLC) $(TARGET_FLAG)
	make -C libs/objsize OCAMLOPT=$(OCAMLOPT) OCAMLC=$(OCAMLC) $(TARGET_FLAG)
	make -C libs/pcre OCAMLOPT=$(OCAMLOPT) OCAMLC=$(OCAMLC) $(TARGET_FLAG)

haxe: $(MODULES:%=src/%.$(MODULE_EXT))
	$(COMPILER) -o $(OUTPUT) $(NATIVE_LIBS) $(NATIVE_LIB_FLAG) $(LFLAGS) $(LIBS:=.$(LIB_EXT)) $(MODULES:%=src/%.$(MODULE_EXT))

haxelib:
	(cd $(CURDIR)/extra/haxelib_src && $(CURDIR)/$(OUTPUT) client.hxml && nekotools boot run.n)
	mv extra/haxelib_src/run$(EXTENSION) haxelib$(EXTENSION)

tools: haxelib

install: uninstall
	mkdir -p $(INSTALL_BIN_DIR)
	mkdir -p $(INSTALL_LIB_DIR)/lib
	cp -rf std $(INSTALL_STD_DIR)
	cp -rf extra $(INSTALL_LIB_DIR)
	cp haxe $(INSTALL_LIB_DIR)
	ln -s $(INSTALL_LIB_DIR)/haxe $(INSTALL_BIN_DIR)/haxe
	cp haxelib $(INSTALL_LIB_DIR)
	ln -s $(INSTALL_LIB_DIR)/haxelib $(INSTALL_BIN_DIR)/haxelib
	chmod -R a+rx $(INSTALL_LIB_DIR)
	chmod 777 $(INSTALL_LIB_DIR)/lib
	chmod a+rx $(INSTALL_BIN_DIR)/haxe $(INSTALL_BIN_DIR)/haxelib

# will install native version of the tools instead of script ones
install_tools: tools
	cp haxelib ${INSTALL_BIN_DIR}/haxelib
	chmod a+rx $(INSTALL_BIN_DIR)/haxelib

uninstall:
	rm -rf $(INSTALL_BIN_DIR)/haxe $(INSTALL_BIN_DIR)/haxelib
	if [ -d "$(INSTALL_LIB_DIR)/lib" ] && find "$(INSTALL_LIB_DIR)/lib" -mindepth 1 -print -quit | grep -q .; then \
		echo "The local haxelib repo at $(INSTALL_LIB_DIR)/lib will not be removed. Remove it manually if you want."; \
		find $(INSTALL_LIB_DIR)/ ! -name 'lib' -mindepth 1 -maxdepth 1 -exec rm -rf {} +; \
	else \
		rm -rf $(INSTALL_LIB_DIR); \
	fi


# Modules

# context

src/context/common.$(MODULE_EXT): src/globals.$(MODULE_EXT) src/typing/type.$(MODULE_EXT) src/syntax/ast.$(MODULE_EXT) src/display/displayTypes.$(MODULE_EXT) libs/ilib/il.$(LIB_EXT)

src/context/meta.$(MODULE_EXT): src/globals.$(MODULE_EXT)

# display

src/display/display.$(MODULE_EXT): src/globals.$(MODULE_EXT) src/context/meta.$(MODULE_EXT) src/path.$(MODULE_EXT) src/syntax/ast.$(MODULE_EXT) src/context/common.$(MODULE_EXT) src/typing/type.$(MODULE_EXT) src/typing/typecore.$(MODULE_EXT) src/syntax/parser.$(MODULE_EXT) src/display/displayTypes.$(MODULE_EXT)

src/display/displayTypes.$(MODULE_EXT) : src/globals.$(MODULE_EXT) src/syntax/ast.$(MODULE_EXT)

src/display/displayOutput.$(MODULE_EXT): src/globals.$(MODULE_EXT) src/typing/type.$(MODULE_EXT) src/typing/typer.$(MODULE_EXT) src/context/common.$(MODULE_EXT) src/display/display.$(MODULE_EXT)

# generators

src/generators/codegen.$(MODULE_EXT): src/globals.$(MODULE_EXT) src/typing/type.$(MODULE_EXT) src/generators/genxml.$(MODULE_EXT) src/context/common.$(MODULE_EXT) src/syntax/ast.$(MODULE_EXT)

src/generators/genas3.$(MODULE_EXT): src/typing/abstract.$(MODULE_EXT) src/globals.$(MODULE_EXT) src/context/meta.$(MODULE_EXT) src/typing/type.$(MODULE_EXT) src/context/common.$(MODULE_EXT) src/generators/codegen.$(MODULE_EXT) src/syntax/ast.$(MODULE_EXT)

src/generators/gencommon.$(MODULE_EXT): src/typing/abstract.$(MODULE_EXT) src/context/meta.$(MODULE_EXT) src/globals.$(MODULE_EXT) src/typing/error.$(MODULE_EXT) src/typing/overloads.$(MODULE_EXT) src/path.$(MODULE_EXT) src/typing/type.$(MODULE_EXT) src/context/common.$(MODULE_EXT) src/generators/codegen.$(MODULE_EXT) src/syntax/ast.$(MODULE_EXT) libs/ilib/il.$(LIB_EXT)

src/generators/gencpp.$(MODULE_EXT): src/typing/abstract.$(MODULE_EXT) src/globals.$(MODULE_EXT) src/context/meta.$(MODULE_EXT) src/path.$(MODULE_EXT) src/typing/type.$(MODULE_EXT) src/syntax/lexer.$(MODULE_EXT) src/context/common.$(MODULE_EXT) src/generators/codegen.$(MODULE_EXT) src/syntax/ast.$(MODULE_EXT)

src/generators/gencs.$(MODULE_EXT): src/typing/abstract.$(MODULE_EXT) src/globals.$(MODULE_EXT) src/context/meta.$(MODULE_EXT) src/path.$(MODULE_EXT) src/typing/type.$(MODULE_EXT) src/syntax/lexer.$(MODULE_EXT) src/generators/gencommon.$(MODULE_EXT) src/context/common.$(MODULE_EXT) src/generators/codegen.$(MODULE_EXT) src/syntax/ast.$(MODULE_EXT) libs/ilib/il.$(LIB_EXT)

src/generators/genjava.$(MODULE_EXT): src/typing/abstract.$(MODULE_EXT) src/globals.$(MODULE_EXT) src/context/meta.$(MODULE_EXT) src/path.$(MODULE_EXT) src/typing/type.$(MODULE_EXT) src/generators/gencommon.$(MODULE_EXT) src/context/common.$(MODULE_EXT) src/generators/codegen.$(MODULE_EXT) src/syntax/ast.$(MODULE_EXT)

src/generators/genjs.$(MODULE_EXT): src/typing/abstract.$(MODULE_EXT) src/globals.$(MODULE_EXT) src/context/meta.$(MODULE_EXT) src/path.$(MODULE_EXT) src/typing/type.$(MODULE_EXT) src/syntax/lexer.$(MODULE_EXT) src/context/common.$(MODULE_EXT) src/generators/codegen.$(MODULE_EXT) src/syntax/ast.$(MODULE_EXT)

src/generators/genneko.$(MODULE_EXT): src/globals.$(MODULE_EXT) src/typing/type.$(MODULE_EXT) src/syntax/lexer.$(MODULE_EXT) src/context/common.$(MODULE_EXT) src/generators/codegen.$(MODULE_EXT) src/syntax/ast.$(MODULE_EXT)

src/generators/genlua.$(MODULE_EXT): src/typing/abstract.$(MODULE_EXT) src/globals.$(MODULE_EXT) src/context/meta.$(MODULE_EXT) src/typing/type.$(MODULE_EXT) src/syntax/lexer.$(MODULE_EXT) src/context/common.$(MODULE_EXT) src/generators/codegen.$(MODULE_EXT) src/syntax/ast.$(MODULE_EXT)

src/generators/genphp.$(MODULE_EXT): src/typing/abstract.$(MODULE_EXT) src/globals.$(MODULE_EXT) src/context/meta.$(MODULE_EXT) src/typing/type.$(MODULE_EXT) src/syntax/lexer.$(MODULE_EXT) src/context/common.$(MODULE_EXT) src/generators/codegen.$(MODULE_EXT) src/syntax/ast.$(MODULE_EXT)

src/generators/genpy.$(MODULE_EXT): src/typing/abstract.$(MODULE_EXT) src/globals.$(MODULE_EXT) src/context/meta.$(MODULE_EXT) src/typing/type.$(MODULE_EXT) src/syntax/lexer.$(MODULE_EXT) src/context/common.$(MODULE_EXT) src/generators/codegen.$(MODULE_EXT) src/syntax/ast.$(MODULE_EXT)

src/generators/genswf.$(MODULE_EXT): src/globals.$(MODULE_EXT) src/typing/type.$(MODULE_EXT) src/generators/genswf9.$(MODULE_EXT) src/context/common.$(MODULE_EXT) src/syntax/ast.$(MODULE_EXT)

src/generators/hlinterp.$(MODULE_EXT): src/context/common.$(MODULE_EXT) src/generators/hlcode.$(MODULE_EXT) src/macro/interp.$(MODULE_EXT) src/generators/hlopt.$(MODULE_EXT) src/macro/macroApi.$(MODULE_EXT)

src/generators/genphp7.$(MODULE_EXT): src/typing/abstract.$(MODULE_EXT) src/globals.$(MODULE_EXT) src/context/meta.$(MODULE_EXT) src/path.$(MODULE_EXT) src/typing/type.$(MODULE_EXT) src/syntax/lexer.$(MODULE_EXT) src/context/common.$(MODULE_EXT) src/generators/codegen.$(MODULE_EXT) src/syntax/ast.$(MODULE_EXT)

src/generators/hl2c.$(MODULE_EXT): src/generators/hlcode.$(MODULE_EXT) src/context/common.$(MODULE_EXT)

src/generators/hlopt.$(MODULE_EXT): src/generators/hlcode.$(MODULE_EXT)

src/generators/genhl.$(MODULE_EXT): src/globals.$(MODULE_EXT) src/context/meta.$(MODULE_EXT) src/typing/type.$(MODULE_EXT) src/syntax/lexer.$(MODULE_EXT) src/context/common.$(MODULE_EXT) src/generators/codegen.$(MODULE_EXT) src/syntax/ast.$(MODULE_EXT) src/generators/hlcode.$(MODULE_EXT) src/generators/hlinterp.$(MODULE_EXT) src/generators/hl2c.$(MODULE_EXT) src/generators/hlopt.$(MODULE_EXT)

src/generators/genswf9.$(MODULE_EXT): src/typing/abstract.$(MODULE_EXT) src/globals.$(MODULE_EXT) src/context/meta.$(MODULE_EXT) src/path.$(MODULE_EXT) src/typing/type.$(MODULE_EXT) src/syntax/lexer.$(MODULE_EXT) src/context/common.$(MODULE_EXT) src/generators/codegen.$(MODULE_EXT) src/syntax/ast.$(MODULE_EXT)

src/generators/genxml.$(MODULE_EXT): src/globals.$(MODULE_EXT) src/context/meta.$(MODULE_EXT) src/typing/type.$(MODULE_EXT) src/syntax/lexer.$(MODULE_EXT) src/context/common.$(MODULE_EXT) src/syntax/ast.$(MODULE_EXT)

# macro

=== debian/changelog ===
haxe (1:3.4.0-1) unstable; urgency=low

  * New upstream version.
    + Depends on PCRE.
    + There is no bundled jQuery source file, thus, remove +dfsg tag.
    + Remove dependencies of libjs-jquery and libjs-swfobject.
    + Remove upstream applied patch.
    + Update d/copyright.
  * Update d/watch and get-orig-source target (no +dfsg).
  * Bump Standards-Version to 3.9.8 (no changes).

 -- Andy Li <andy@onthewings.net>  Thu, 02 Feb 2017 09:27:56 +0800

=== debian/control ===
Source: haxe
Section: devel
Priority: optional
Maintainer: Andy Li <andy@onthewings.net>
Standards-Version: 3.9.8
Build-Depends: camlp4 (>= 3.11),
               debhelper (>= 9),
               libxml-light-ocaml-dev,
               neko (>= 2.0.0~),
               ocaml,
               ocaml-best-compilers | ocaml-native-compilers,
               ocaml-findlib,
               zlib1g-dev,
               libpcre3-dev,
               bash-completion
Vcs-Git: https://github.com/HaxeFoundation/haxe-debian.git
Vcs-Browser: https://github.com/HaxeFoundation/haxe-debian
Homepage: http://haxe.org

Package: haxe
Architecture: any
Depends: neko (>= 2.0.0),
         ${misc:Depends},
         ${ocaml:Depends},
         ${shlibs:Depends}
Description: multi-target universal programming language
 Haxe is an open source toolkit based on a modern,
 high level, strictly typed programming language, a cross-compiler,
 a complete cross-platform standard library and ways to access each
 platform's native capabilities.

=== debian/watch ===
version=3
opts="uversionmangle=s/-/~/g"\
 https://github.com/HaxeFoundation/haxe/releases .*/(\d\S*)\.tar\.gz

## haxe 3.4.2

=== Makefile ===
--- 
+++ 
@@ -67,7 +67,7 @@
 MODULES=json version globals path context/meta syntax/ast display/displayTypes typing/type typing/error \
 	syntax/lexer context/common generators/genxml \
 	syntax/parser typing/abstract typing/typecore display/display optimization/optimizerTexpr \
-	optimization/optimizer typing/overloads typing/typeload generators/codegen generators/gencommon generators/genas3 \
+	optimization/optimizer typing/overloads typing/typeload sourcemaps generators/codegen generators/gencommon generators/genas3 \
 	generators/gencpp generators/genjs generators/genneko generators/genphp generators/genphp7 generators/genswf9 \
 	generators/genswf generators/genjava generators/gencs generators/genpy macro/macroApi macro/interp generators/hlcode generators/hlopt generators/hlinterp generators/hl2c \
 	generators/genlua \
@@ -164,6 +164,10 @@
 
 src/display/displayOutput.$(MODULE_EXT): src/globals.$(MODULE_EXT) src/typing/type.$(MODULE_EXT) src/typing/typer.$(MODULE_EXT) src/context/common.$(MODULE_EXT) src/display/display.$(MODULE_EXT)
 
+# sourcemaps
+
+src/sourcemaps.$(MODULE_EXT): src/globals.$(MODULE_EXT) src/context/common.$(MODULE_EXT) src/syntax/lexer.$(MODULE_EXT) src/syntax/ast.$(MODULE_EXT)
+
 # generators
 
 src/generators/codegen.$(MODULE_EXT): src/globals.$(MODULE_EXT) src/typing/type.$(MODULE_EXT) src/generators/genxml.$(MODULE_EXT) src/context/common.$(MODULE_EXT) src/syntax/ast.$(MODULE_EXT)
@@ -192,7 +196,7 @@
 
 src/generators/hlinterp.$(MODULE_EXT): src/context/common.$(MODULE_EXT) src/generators/hlcode.$(MODULE_EXT) src/macro/interp.$(MODULE_EXT) src/generators/hlopt.$(MODULE_EXT) src/macro/macroApi.$(MODULE_EXT)
 
-src/generators/genphp7.$(MODULE_EXT): src/typing/abstract.$(MODULE_EXT) src/globals.$(MODULE_EXT) src/context/meta.$(MODULE_EXT) src/path.$(MODULE_EXT) src/typing/type.$(MODULE_EXT) src/syntax/lexer.$(MODULE_EXT) src/context/common.$(MODULE_EXT) src/generators/codegen.$(MODULE_EXT) src/syntax/ast.$(MODULE_EXT)
+src/generators/genphp7.$(MODULE_EXT): src/typing/abstract.$(MODULE_EXT) src/globals.$(MODULE_EXT) src/context/meta.$(MODULE_EXT) src/path.$(MODULE_EXT) src/typing/type.$(MODULE_EXT) src/syntax/lexer.$(MODULE_EXT) src/context/common.$(MODULE_EXT) src/generators/codegen.$(MODULE_EXT) src/syntax/ast.$(MODULE_EXT) src/sourcemaps.$(MODULE_EXT)
 
 src/generators/hl2c.$(MODULE_EXT): src/generators/hlcode.$(MODULE_EXT) src/context/common.$(MODULE_EXT)
 
@@ -202,7 +206,3 @@
 
 src/generators/genswf9.$(MODULE_EXT): src/typing/abstract.$(MODULE_EXT) src/globals.$(MODULE_EXT) src/context/meta.$(MODULE_EXT) src/path.$(MODULE_EXT) src/typing/type.$(MODULE_EXT) src/syntax/lexer.$(MODULE_EXT) src/context/common.$(MODULE_EXT) src/generators/codegen.$(MODULE_EXT) src/syntax/ast.$(MODULE_EXT)
 
-src/generators/genxml.$(MODULE_EXT): src/globals.$(MODULE_EXT) src/context/meta.$(MODULE_EXT) src/typing/type.$(MODULE_EXT) src/syntax/lexer.$(MODULE_EXT) src/context/common.$(MODULE_EXT) src/syntax/ast.$(MODULE_EXT)
-
-# macro
-

=== debian/changelog ===
haxe (1:3.4.2-1ubuntu1) artful; urgency=medium

  * Drop dependencies on best/native ocaml compilers.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 08 Aug 2017 13:40:24 -0400

haxe (1:3.4.2-1) unstable; urgency=low

  * New upstream version.
  * Fix d/watch.

 -- Andy Li <andy@onthewings.net>  Thu, 23 Mar 2017 10:39:18 +0800

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,14 @@
 Source: haxe
 Section: devel
 Priority: optional
-Maintainer: Andy Li <andy@onthewings.net>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Andy Li <andy@onthewings.net>
 Standards-Version: 3.9.8
 Build-Depends: camlp4 (>= 3.11),
                debhelper (>= 9),
                libxml-light-ocaml-dev,
                neko (>= 2.0.0~),
                ocaml,
-               ocaml-best-compilers | ocaml-native-compilers,
                ocaml-findlib,
                zlib1g-dev,
                libpcre3-dev,

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for Haxe.

%:
	dh $@ --with bash-completion

PKD   = $(abspath $(dir $(MAKEFILE_LIST)))
PKG   = haxe
VER  = $(shell dpkg-parsechangelog -l$(PKD)/changelog | perl -ne 'print $$1 if m{^Version:\s+(?:\d+:)?(\d.*)(?:\-\d+.*)};')

override_dh_auto_configure:

override_dh_auto_build:
	# Check to see if ocamlopt exists. If not, bytecompile everything.
	command -v ocamlopt && dh_auto_build || dh_auto_build -- BYTECODE=1
	# Compile haxelib to neko
	dh_auto_build -- tools

override_dh_auto_install:

override_dh_strip:
	# haxelib is the neko vm appended with neko bytecode. It should not be stripped
	dh_strip --exclude=haxelib

get-orig-source:
	# create tar manually from git, in order to get submodules
	git clone --branch $(VER) --depth 1 --recursive https://github.com/HaxeFoundation/haxe.git orig-source
	cd orig-source && \
		python $(CURDIR)/debian/git-archive-all ../../$(PKG)_$(VER)$(DTYPE).orig.tar.gz
	rm -rf orig-source

=== debian/watch ===
version=3
opts="uversionmangle=s/-/~/g"\
 https://github.com/HaxeFoundation/haxe/releases .*/archive/(\d\S*)\.tar\.gz

## haxe 3.4.4

=== Makefile ===
--- 
+++ 
@@ -15,6 +15,7 @@
 INSTALL_LIB_DIR=$(INSTALL_DIR)/lib/haxe
 INSTALL_STD_DIR=$(INSTALL_LIB_DIR)/std
 PACKAGE_OUT_DIR=out
+INSTALLER_TMP_DIR=installer
 PACKAGE_SRC_EXTENSION=.tar.gz
 
 PLATFORM?=unix

=== libs/extc/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-CFLAGS = -I zlib
+ALL_CFLAGS = $(CFLAGS)
 LIBS = -I ../extlib
 OCAMLOPT=ocamlopt
 OCAMLC=ocamlc
@@ -17,13 +17,13 @@
 	$(OCAMLOPT) -a -o extc.cmxa $(LIBS) extc.ml process.ml
 
 extc_stubs.o: extc_stubs.c
-	$(OCAMLC) $(CFLAGS) extc_stubs.c
+	$(OCAMLC) $(ALL_CFLAGS) extc_stubs.c
 
 process_stubs.o: process_stubs.c
-	$(OCAMLC) $(CFLAGS) process_stubs.c
+	$(OCAMLC) $(ALL_CFLAGS) process_stubs.c
 	
 clean:
-	rm -f extc.cma extc.cmi extc.cmx extc.cmxa extc.o extc.obj extc.lib extc_stubs.obj extc_stubs.o process.cmx process.obj process.cmi process_stubs.obj process_stubs.o
+	rm -f extc.cma extc.cmi extc.cmx extc.cmxa extc.o extc.obj extc.lib extc_stubs.obj extc_stubs.o process.cmx process.obj process.cmi process.o process_stubs.obj process_stubs.o
 	rm -f extc.a libextc.a libextc.lib extc.cmo process.cmo
 
 test: native

=== libs/javalib/Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 OCAMLOPT=ocamlopt
 OCAMLC=ocamlc
-SRC=jData.ml jReader.ml
+SRC=jData.ml jReader.ml jWriter.ml
 
 all: bytecode native

=== libs/neko/Makefile ===
OCAMLOPT=ocamlopt
OCAMLC=ocamlc
SRC=nast.ml nxml.ml binast.ml nbytecode.ml ncompile.ml

all: bytecode native

native: neko.cmxa

bytecode: neko.cma

neko.cmxa: $(SRC)
	$(OCAMLOPT) -I ../extlib -a -o neko.cmxa $(SRC)

neko.cma: $(SRC)
	$(OCAMLC) -I ../extlib -a -o neko.cma $(SRC)

clean:
	rm -rf neko.cmxa neko.cma neko.lib neko.a $(wildcard *.cmx) $(wildcard *.obj) $(wildcard *.o) $(wildcard *.cmi) $(wildcard *.cmo)

.PHONY: all bytecode native clean

Makefile: ;
$(SRC): ;

=== libs/swflib/Makefile ===
--- 
+++ 
@@ -4,7 +4,7 @@
 OCAMLC=ocamlc
 .SUFFIXES : .ml .mli .cmo .cmi .cmx .mll .mly
 
-CFLAGS= -I ../extlib -I ../extc -g
+ALL_CFLAGS= $(CFLAGS) -I ../extlib -I ../extc -g
 LIBS=
 
 SRC=actionScript.ml as3hl.mli as3.mli png.ml swflib.sln swf.ml swfPic.ml as3code.ml as3hlparse.ml as3parse.ml png.mli swfParser.ml
@@ -61,13 +61,13 @@
 
 # SUFFIXES
 .ml.cmo:
-	$(OCAMLC) $(CFLAGS) -c $<
+	$(OCAMLC) $(ALL_CFLAGS) -c $<
 
 .ml.cmx:
-	$(OCAMLOPT) $(CFLAGS) -c $<
+	$(OCAMLOPT) $(ALL_CFLAGS) -c $<
 
 .mli.cmi:
-	$(OCAMLC) $(CFLAGS) $<
+	$(OCAMLC) $(ALL_CFLAGS) $<
 
 .mll.ml:
 	ocamllex $<

=== libs/ziplib/Makefile ===
OCAMLOPT=ocamlopt
OCAMLC=ocamlc
SRC=zlib.mli zlib.ml zip.mli zip.ml

all: native bytecode

native: zip.cmxa
zip.cmxa: $(SRC)
	$(OCAMLOPT) -g -I ../extlib -I ../extc -a -o zip.cmxa $(SRC)

bytecode: zip.cma
zip.cma: $(SRC)
	$(OCAMLC) -g -I ../extlib -I ../extc -a -o zip.cma $(SRC)

clean:
	rm -rf zip.cmxa zip.cma zip.lib zip.a $(wildcard *.cmx) $(wildcard *.obj) $(wildcard *.o) $(wildcard *.cmi) $(wildcard *.cmo)

.PHONY: all native bytecode clean

Makefile: ;

$(SRC): ;

=== debian/changelog ===
haxe (1:3.4.4-2) unstable; urgency=low

  * Use dh_ocaml for ocamlopt detection.
  * Remove redundant ocaml-best-compilers, ocaml-native-compilers depends.
  * Add dh_missing.
  * Add autopkgtest support.

 -- Andy Li <andy@onthewings.net>  Tue, 21 Nov 2017 15:30:27 +0800

haxe (1:3.4.4-1) unstable; urgency=medium

  * New upstream version.
    + Fix flash target broken when compiled with OCaml 4.05.
  * Bump Standards-Version to 4.1.1 (no changes).
  * Update d/rules to use /usr/share/dpkg/pkg-info.mk to get source version.
  * Update d/watch to use the GitHub latest release page to avoid getting
    pre-release version.

 -- Andy Li <andy@onthewings.net>  Mon, 09 Oct 2017 09:50:21 +0800

haxe (1:3.4.3-1) unstable; urgency=low

  * New upstream version.
  * Remove hardening-* lintian overrides.
  * Bump Standards-Version to 4.1.0 (no changes).

 -- Andy Li <andy@onthewings.net>  Mon, 25 Sep 2017 13:38:07 +0800

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,15 @@
 Source: haxe
 Section: devel
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Andy Li <andy@onthewings.net>
-Standards-Version: 3.9.8
-Build-Depends: camlp4 (>= 3.11),
-               debhelper (>= 9),
+Maintainer: Andy Li <andy@onthewings.net>
+Standards-Version: 4.1.1
+Build-Depends: debhelper (>= 9),
+               dh-ocaml,
+               ocaml-nox,
+               ocaml-findlib,
+               camlp4 (>= 3.11),
                libxml-light-ocaml-dev,
                neko (>= 2.0.0~),
-               ocaml,
-               ocaml-findlib,
                zlib1g-dev,
                libpcre3-dev,
                bash-completion

=== debian/watch ===
version=3
opts="uversionmangle=s/-/~/g"\
 https://github.com/HaxeFoundation/haxe/releases/latest .*/archive/(\d\S*)\.tar\.gz

## haxe 3.4.7

=== libs/ilib/Makefile ===
OCAMLOPT=ocamlopt
OCAMLC=ocamlc

SRCS=peData.ml peReader.ml peWriter.ml ilMeta.mli ilData.mli ilMetaTools.ml ilMetaDebug.ml ilMetaReader.ml

all: native bytecode

native: il.cmxa
bytecode: il.cma

il.cmxa: $(SRCS)
	$(OCAMLOPT) -g -I ../extlib -a -o il.cmxa $(SRCS)

il.cma: $(SRCS)
	$(OCAMLC) -g -I ../extlib -a -o il.cma $(SRCS)

dump: il.cmxa dump.ml peDataDebug.ml ilMetaDebug.ml
	$(OCAMLOPT) -g -I ../extlib -o dump ../extlib/extLib.cmxa il.cmxa peDataDebug.ml dump.ml

clean:
	rm -f il.cma il.cmxa il.lib il.a $(wildcard *.cmx) $(wildcard *.cmo) $(wildcard *.obj) $(wildcard *.o) $(wildcard *.cmi) dump

.PHONY: all bytecode native clean

Makefile: ;
$(SRCS): ;

=== debian/changelog ===
haxe (1:3.4.7-2) unstable; urgency=medium

  * Add camlp5.diff that replaces camlp4 with camlp5 (#933722).
  * Use https for Homepage.
  * Bump Standards-Version to 4.4.0 (no changes).

 -- Andy Li <andy@onthewings.net>  Mon, 12 Aug 2019 10:38:36 +0800

haxe (1:3.4.7-1) unstable; urgency=low

  * New upstream version.
  * Bump Standards-Version to 4.1.3 (no changes).

 -- Andy Li <andy@onthewings.net>  Mon, 26 Mar 2018 09:55:24 +0800

=== debian/control ===
--- 
+++ 
@@ -2,12 +2,12 @@
 Section: devel
 Priority: optional
 Maintainer: Andy Li <andy@onthewings.net>
-Standards-Version: 4.1.1
+Standards-Version: 4.4.0
 Build-Depends: debhelper (>= 9),
                dh-ocaml,
                ocaml-nox,
                ocaml-findlib,
-               camlp4 (>= 3.11),
+               camlp5,
                libxml-light-ocaml-dev,
                neko (>= 2.0.0~),
                zlib1g-dev,
@@ -15,7 +15,7 @@
                bash-completion
 Vcs-Git: https://github.com/HaxeFoundation/haxe-debian.git
 Vcs-Browser: https://github.com/HaxeFoundation/haxe-debian
-Homepage: http://haxe.org
+Homepage: https://haxe.org
 
 Package: haxe
 Architecture: any

## haxe 4.0.2

=== debian/changelog ===
haxe (1:4.0.2-1) unstable; urgency=medium

  * New upstream version.

 -- Andy Li <andy@onthewings.net>  Tue, 12 Nov 2019 12:37:34 +0800

haxe (1:4.0.1-1) unstable; urgency=medium

  * New upstream version.
    + Safe-strings compatible (Closes: #939961).
  * Remove camlp5.diff, which is no longer needed.
  * Bump Standards-Version to 4.4.1 (no changes).

 -- Andy Li <andy@onthewings.net>  Sun, 10 Nov 2019 21:25:41 +0800
